//---------------------------------------------------------------------------------
//                                                                                 
//---------------------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  PaleVioletRed
#property indicator_width2  2
#property indicator_style1  STYLE_DOT

//
//
//
//
//

extern int    Window                = 512;
extern double Treshold              = 0.03;
extern int    Price                 = PRICE_CLOSE;
extern  int   Lag                   = 0;
extern int    RegressionDegree      = 3;
extern int    RegressionSampleSize  = 0;
extern bool   DetrendingLineVisible = true;

//
//
//
//
//

double lr[];
double fft[];
double prices[];
double work[];

//---------------------------------------------------------------------------------
//                                                                                 
//---------------------------------------------------------------------------------
//
//
//
//
//

int init()
{
   int style = DRAW_NONE; if (DetrendingLineVisible) style = DRAW_LINE;
   IndicatorBuffers(3);
      SetIndexBuffer(0,lr);   SetIndexStyle(0,style);
      SetIndexBuffer(1,fft);
      SetIndexBuffer(2,prices);
   return(0);
}
void deinit() {}


//---------------------------------------------------------------------------------
//                                                                                 
//---------------------------------------------------------------------------------
//
//
//
//
//

#define pi 3.14159265358979323846
double wa[20,20],wb[20],wx[20],s[40];

//
//
//
//
//

int start()
{
   int i,k,n,N,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
           
         n = NormalizeDouble(MathLog(Window)/MathLog(2),0);
         N = MathMax(MathPow(2,n),16);
            if (N > Bars-1)
            {
                n = NormalizeDouble(MathLog(Bars)/MathLog(2),0);
                N = MathMax(MathPow(2,n),16);
                    if (N>=Bars) N = MathMax(MathPow(2,n-1),16);
            }      
         if (N >= Bars) return(0);
         if (ArraySize(work)!=N) ArrayResize(work,N);

         //
         //
         //
         //
         //

            for(i=limit; i>=0; i--) prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i+Lag);

                  int ssLength = MathMax(N,RegressionSampleSize);
                  int d        = RegressionDegree+1;  
                  if (RegressionDegree>0)
                  {
                     s[1] = ssLength+1; double sum ;
                        for(k=1; k<=d*2-2; k++) { sum=0; for(n=0; n<=ssLength; n++) sum += MathPow(n,k); s[k+1] = sum; }
                        for(k=1; k<=d;     k++) { sum=0; for(n=0; n<=ssLength; n++) sum += prices[n]*MathPow(n,k-1); wb[k] = sum; }
                        for(k=1; k<=d;     k++)          for(n=1; n<=d;        n++) wa[n,k]=s[k+n-1]; 
                  
                        if (!iCalc(d,wa,wb,wx)) return(0);
                           for(i=ssLength-1; i>=0; i--) { for(n=1,sum=0; n<d; n++) sum += wx[n+1]*MathPow(i,n); lr[i] = wx[1]+sum; }  
                  }                  
                  else { double slope = (prices[0]-prices[ssLength-1])/ssLength; for(i=ssLength-1; i>=0; i--) lr[i] = prices[0]-slope*i; }
             
             for(i=N-1; i>=0; i--) work[i] = prices[i]-lr[i];

         //
         //
         //
         //
         //
      
         realFastFourierTransform(work,N,false);

                  for(i=1; i<N/2; i++)
                  {
                     double amp = MathSqrt(work[i*2]*work[i*2]+work[i*2+1]*work[i*2+1]); 
                     double add = 0;
   
                     if (!(work[i*2]>0)) add = pi;
         
                     double   phase = MathArctan(work[i*2+1]/work[i*2]); 
                              work[i*2]   = amp*MathCos(phase+add);
                              work[i*2+1] = amp*MathSin(phase+add);
                  }
                  double power = 0; for(i=1; i<N/2; i++) power += MathSqrt(work[i*2]*work[i*2]+work[i*2+1]*work[i*2+1]); 
                  double treshold = power*Treshold;
      
                  for( i=1; i<N/2; i++)
                  {
                     double tmp = MathSqrt(work[i*2]*work[i*2]+work[i*2+1]*work[i*2+1]); 
                        if( tmp < treshold) { work[i*2] = 0; work[i*2+1] = 0; }
                  }

         realFastFourierTransform(work, N, true); 
         for(i=N-2; i>=0; i--)
            if(i>0) 
                  fft[i]=(work[i+1]+lr[i+1]+2.0*work[i]+2.0*lr[i]+work[i-1]+lr[i-1])/4.0;
            else  fft[i]=(work[i+1]+lr[i+1]+2.0*work[i]+2.0*lr[i])/3.0;
                     

         //
         //
         //
         //
         //
         //
              
         SetIndexDrawBegin(0,Bars-ssLength+1);
         SetIndexDrawBegin(1,Bars-N+1);
   return(0);
}



//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

bool iCalc(int n, double& a[][],double& b[], double& x[]) 
{
   int i,j,k; double t,q;

   for(k = 1; k <=n-1; k++) 
   {
      int    l = 0; 
      double m = 0; 
         for(i=k; i<=n; i++) 
            if (MathAbs(a[i,k]) > m) { m = MathAbs(a[i,k]); l = i; } 
            if (l==0) return(false);   

            //
            //
            //
            
            if(l != k) 
            {
               for(j=1; j<=n; j++) { t = a[k,j]; a[k,j] = a[l,j]; a[l,j] = t; } 
                                     t = b[k];   b[k]   = b[l];   b[l]   = t;
            }  
            for(i=k+1; i<=n; i++) 
            {
               q = a[i,k]/a[k,k]; 
                  for(j=1; j<=n; j++) 
                    if (j == k)
                           a[i,j] = 0; 
                    else   a[i,j] = a[i,j] - q*a[k,j];
               b[i] = b[i] - q*b[k];
            }
   }
   
   //
   //
   //
   //
   //
   
      x[n] = b[n] / a[n,n]; 
      for(i=n-1; i>=1; i--) 
      {
         t = 0;  
         for(j = 1; j <= n - i; j++) 
         { 
            t    += a[i,i+j]*x[i+j]; 
            x[i] = (1.0/a[i,i])*(b[i]-t);
         }
      }
   return(true);
}


//---------------------------------------------------------------------------------
//                                                                                 
//---------------------------------------------------------------------------------
//
//
//
//    original realFastFourierTransform written by klot
//
//
//

void realFastFourierTransform(double& a[], int tnn, bool inversefft)
{
    double twr;
    double twi;
    double twpr;
    double twpi;
    double twtemp;
    double ttheta;
    int i;
    int i1;
    int i2;
    int i3;
    int i4;
    double c1;
    double c2;
    double h1r;
    double h1i;
    double h2r;
    double h2i;
    double wrs;
    double wis;
    int nn;
    int ii;
    int jj;
    int n;
    int mmax;
    int m;
    int j;
    int istep;
    int isign;
    double wtemp;
    double wr;
    double wpr;
    double wpi;
    double wi;
    double theta;
    double tempr;
    double tempi;

    if( tnn==1 )
    {
        return;
    }
    if( !inversefft )
    {
        ttheta = 2.0*pi/tnn;
        c1 = 0.5;
        c2 = -0.5;
    }
    else
    {
        ttheta = 2.0*pi/tnn;
        c1 = 0.5;
        c2 = 0.5;
        ttheta = -ttheta;
        twpr = -2.0*MathPow(MathSin(0.5*ttheta),2);
        twpi = MathSin(ttheta);
        twr = 1.0+twpr;
        twi = twpi;
        for(i = 2; i <= tnn/4+1; i++)
        {
            i1 = i+i-2;
            i2 = i1+1;
            i3 = tnn+1-i2;
            i4 = i3+1;
            wrs = twr;
            wis = twi;
            h1r = c1*(a[i1]+a[i3]);
            h1i = c1*(a[i2]-a[i4]);
            h2r = -c2*(a[i2]+a[i4]);
            h2i = c2*(a[i1]-a[i3]);
            a[i1] = h1r+wrs*h2r-wis*h2i;
            a[i2] = h1i+wrs*h2i+wis*h2r;
            a[i3] = h1r-wrs*h2r+wis*h2i;
            a[i4] = -h1i+wrs*h2i+wis*h2r;
            twtemp = twr;
            twr = twr*twpr-twi*twpi+twr;
            twi = twi*twpr+twtemp*twpi+twi;
        }
        h1r = a[0];
        a[0] = c1*(h1r+a[1]);
        a[1] = c1*(h1r-a[1]);
    }
    if( inversefft )
    {
        isign = -1;
    }
    else
    {
        isign = 1;
    }
    n = tnn;
    nn = tnn/2;
    j = 1;
    for(ii = 1; ii <= nn; ii++)
    {
        i = 2*ii-1;
        if( j>i )
        {
            tempr = a[j-1];
            tempi = a[j];
            a[j-1] = a[i-1];
            a[j] = a[i];
            a[i-1] = tempr;
            a[i] = tempi;
        }
        m = n/2;
        while(m>=2&&j>m)
        {
            j = j-m;
            m = m/2;
        }
        j = j+m;
    }
    mmax = 2;
    while(n>mmax)
    {
        istep = 2*mmax;
        theta = 2.0*pi/(isign*mmax);
        wpr = -2.0*MathPow(MathSin(0.5*theta),2);
        wpi = MathSin(theta);
        wr = 1.0;
        wi = 0.0;
        for(ii = 1; ii <= mmax/2; ii++)
        {
            m = 2*ii-1;
            for(jj = 0; jj <= (n-m)/istep; jj++)
            {
                i = m+jj*istep;
                j = i+mmax;
                tempr = wr*a[j-1]-wi*a[j];
                tempi = wr*a[j]+wi*a[j-1];
                a[j-1] = a[i-1]-tempr;
                a[j] = a[i]-tempi;
                a[i-1] = a[i-1]+tempr;
                a[i] = a[i]+tempi;
            }
            wtemp = wr;
            wr = wr*wpr-wi*wpi+wr;
            wi = wi*wpr+wtemp*wpi+wi;
        }
        mmax = istep;
    }
    if( inversefft )
    {
        for(i = 1; i <= 2*nn; i++)
        {
            a[i-1] = a[i-1]/nn;
        }
    }
    if( !inversefft )
    {
        twpr = -2.0*MathPow(MathSin(0.5*ttheta),2);
        twpi = MathSin(ttheta);
        twr = 1.0+twpr;
        twi = twpi;
        for(i = 2; i <= tnn/4+1; i++)
        {
            i1 = i+i-2;
            i2 = i1+1;
            i3 = tnn+1-i2;
            i4 = i3+1;
            wrs = twr;
            wis = twi;
            h1r = c1*(a[i1]+a[i3]);
            h1i = c1*(a[i2]-a[i4]);
            h2r = -c2*(a[i2]+a[i4]);
            h2i = c2*(a[i1]-a[i3]);
            a[i1] = h1r+wrs*h2r-wis*h2i;
            a[i2] = h1i+wrs*h2i+wis*h2r;
            a[i3] = h1r-wrs*h2r+wis*h2i;
            a[i4] = -h1i+wrs*h2i+wis*h2r;
            twtemp = twr;
            twr = twr*twpr-twi*twpi+twr;
            twi = twi*twpr+twtemp*twpi+twi;
        }
        h1r = a[0];
        a[0] = h1r+a[1];
        a[1] = h1r-a[1];
    }
    return;
}